using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Runtime.InteropServices; 
using System.Threading; 
using System.Reflection;

namespace EveMining
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button btnDockedColour;
		private System.Windows.Forms.Button btnDockedGrid;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Label lblDockedTL;
		private System.Windows.Forms.Label lblDockedBR;
		private System.Windows.Forms.Label lblDamagedBR;
		private System.Windows.Forms.Label lblDamagedTL;
		private System.Windows.Forms.Button btnDamagedColour;
		private System.Windows.Forms.Button btnDamagedGrid;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label lblInfoBR;
		private System.Windows.Forms.Label lblInfoTL;
		private System.Windows.Forms.Button btnInfoColour;
		private System.Windows.Forms.Button btnInfoGrid;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.Label label12;
		private System.Windows.Forms.Button btnStart;
		
		public bool alive = true;

		public string action = "waiting";

		public Button[] btnColours = new Button[10];

		public Label[] lblPntTL = new Label[10];
		public Label[] lblPntBR = new Label[10];

		public Point[] pntTL = new Point[10];
		public Point[] pntBR = new Point[10];

		public String[] state = new string[10];

		[DllImport("gdi32.dll")]
		static extern IntPtr CreateDC(string strDriver,string strDevice, string strOutput, IntPtr pData);

		[DllImport("gdi32.dll")]
		static extern bool DeleteDC(IntPtr hdc);

		[DllImport("gdi32.dll")]
		static extern int GetPixel(IntPtr hdc, int nXPos, int nYPos);

		UserActivityHook actHook;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			InitializeComponent();
			actHook= new UserActivityHook();
			actHook.OnMouseActivity+=new MouseEventHandler(MouseMoved);
			btnColours[0] = btnDockedColour; 
			btnColours[1] = btnDamagedColour;
			btnColours[2] = btnInfoColour;

			lblPntTL[0] = lblDockedTL;
			lblPntTL[1] = lblDamagedTL;
			lblPntTL[2] = lblInfoTL;

			lblPntBR[0] = lblDockedBR;
			lblPntBR[1] = lblDamagedBR;
			lblPntBR[2] = lblInfoBR;

			state[0] = "docked";
			state[1] = "damaged";
			state[2] = "info";

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				alive = false;
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnDockedColour = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.btnDockedGrid = new System.Windows.Forms.Button();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.label12 = new System.Windows.Forms.Label();
			this.label11 = new System.Windows.Forms.Label();
			this.label10 = new System.Windows.Forms.Label();
			this.lblInfoBR = new System.Windows.Forms.Label();
			this.lblInfoTL = new System.Windows.Forms.Label();
			this.btnInfoColour = new System.Windows.Forms.Button();
			this.btnInfoGrid = new System.Windows.Forms.Button();
			this.label9 = new System.Windows.Forms.Label();
			this.lblDamagedBR = new System.Windows.Forms.Label();
			this.lblDamagedTL = new System.Windows.Forms.Label();
			this.btnDamagedColour = new System.Windows.Forms.Button();
			this.btnDamagedGrid = new System.Windows.Forms.Button();
			this.label6 = new System.Windows.Forms.Label();
			this.lblDockedBR = new System.Windows.Forms.Label();
			this.lblDockedTL = new System.Windows.Forms.Label();
			this.btnStart = new System.Windows.Forms.Button();
			this.groupBox1.SuspendLayout();
			this.SuspendLayout();
			// 
			// btnDockedColour
			// 
			this.btnDockedColour.Location = new System.Drawing.Point(64, 48);
			this.btnDockedColour.Name = "btnDockedColour";
			this.btnDockedColour.Size = new System.Drawing.Size(64, 24);
			this.btnDockedColour.TabIndex = 0;
			this.btnDockedColour.Click += new System.EventHandler(this.btnDockedColour_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 48);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(56, 24);
			this.label1.TabIndex = 1;
			this.label1.Text = "Docked";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// btnDockedGrid
			// 
			this.btnDockedGrid.Location = new System.Drawing.Point(136, 48);
			this.btnDockedGrid.Name = "btnDockedGrid";
			this.btnDockedGrid.Size = new System.Drawing.Size(40, 24);
			this.btnDockedGrid.TabIndex = 2;
			this.btnDockedGrid.Text = "Grid";
			this.btnDockedGrid.Click += new System.EventHandler(this.btnDockedGrid_Click);
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.label12);
			this.groupBox1.Controls.Add(this.label11);
			this.groupBox1.Controls.Add(this.label10);
			this.groupBox1.Controls.Add(this.lblInfoBR);
			this.groupBox1.Controls.Add(this.lblInfoTL);
			this.groupBox1.Controls.Add(this.btnInfoColour);
			this.groupBox1.Controls.Add(this.btnInfoGrid);
			this.groupBox1.Controls.Add(this.label9);
			this.groupBox1.Controls.Add(this.lblDamagedBR);
			this.groupBox1.Controls.Add(this.lblDamagedTL);
			this.groupBox1.Controls.Add(this.btnDamagedColour);
			this.groupBox1.Controls.Add(this.btnDamagedGrid);
			this.groupBox1.Controls.Add(this.label6);
			this.groupBox1.Controls.Add(this.lblDockedBR);
			this.groupBox1.Controls.Add(this.lblDockedTL);
			this.groupBox1.Controls.Add(this.btnDockedColour);
			this.groupBox1.Controls.Add(this.btnDockedGrid);
			this.groupBox1.Controls.Add(this.label1);
			this.groupBox1.Location = new System.Drawing.Point(8, 8);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(272, 176);
			this.groupBox1.TabIndex = 3;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "State detection";
			// 
			// label12
			// 
			this.label12.Location = new System.Drawing.Point(136, 16);
			this.label12.Name = "label12";
			this.label12.Size = new System.Drawing.Size(120, 23);
			this.label12.TabIndex = 17;
			this.label12.Text = "Scan Area";
			this.label12.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label11
			// 
			this.label11.Location = new System.Drawing.Point(64, 16);
			this.label11.Name = "label11";
			this.label11.Size = new System.Drawing.Size(64, 23);
			this.label11.TabIndex = 16;
			this.label11.Text = "Colour";
			this.label11.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label10
			// 
			this.label10.Location = new System.Drawing.Point(8, 16);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(56, 23);
			this.label10.TabIndex = 15;
			this.label10.Text = "State";
			this.label10.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblInfoBR
			// 
			this.lblInfoBR.Location = new System.Drawing.Point(184, 144);
			this.lblInfoBR.Name = "lblInfoBR";
			this.lblInfoBR.Size = new System.Drawing.Size(80, 16);
			this.lblInfoBR.TabIndex = 14;
			this.lblInfoBR.Text = "BR = 0";
			// 
			// lblInfoTL
			// 
			this.lblInfoTL.Location = new System.Drawing.Point(184, 128);
			this.lblInfoTL.Name = "lblInfoTL";
			this.lblInfoTL.Size = new System.Drawing.Size(80, 16);
			this.lblInfoTL.TabIndex = 13;
			this.lblInfoTL.Text = "TL = 0";
			// 
			// btnInfoColour
			// 
			this.btnInfoColour.Location = new System.Drawing.Point(64, 128);
			this.btnInfoColour.Name = "btnInfoColour";
			this.btnInfoColour.Size = new System.Drawing.Size(64, 24);
			this.btnInfoColour.TabIndex = 10;
			this.btnInfoColour.Click += new System.EventHandler(this.btnInfoColour_Click);
			// 
			// btnInfoGrid
			// 
			this.btnInfoGrid.Location = new System.Drawing.Point(136, 128);
			this.btnInfoGrid.Name = "btnInfoGrid";
			this.btnInfoGrid.Size = new System.Drawing.Size(40, 24);
			this.btnInfoGrid.TabIndex = 12;
			this.btnInfoGrid.Text = "Grid";
			this.btnInfoGrid.Click += new System.EventHandler(this.btnInfoGrid_Click);
			// 
			// label9
			// 
			this.label9.Location = new System.Drawing.Point(8, 128);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(56, 24);
			this.label9.TabIndex = 11;
			this.label9.Text = "Info";
			this.label9.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblDamagedBR
			// 
			this.lblDamagedBR.Location = new System.Drawing.Point(184, 104);
			this.lblDamagedBR.Name = "lblDamagedBR";
			this.lblDamagedBR.Size = new System.Drawing.Size(80, 16);
			this.lblDamagedBR.TabIndex = 9;
			this.lblDamagedBR.Text = "BR = 0";
			// 
			// lblDamagedTL
			// 
			this.lblDamagedTL.Location = new System.Drawing.Point(184, 88);
			this.lblDamagedTL.Name = "lblDamagedTL";
			this.lblDamagedTL.Size = new System.Drawing.Size(80, 16);
			this.lblDamagedTL.TabIndex = 8;
			this.lblDamagedTL.Text = "TL = 0";
			// 
			// btnDamagedColour
			// 
			this.btnDamagedColour.Location = new System.Drawing.Point(64, 88);
			this.btnDamagedColour.Name = "btnDamagedColour";
			this.btnDamagedColour.Size = new System.Drawing.Size(64, 24);
			this.btnDamagedColour.TabIndex = 5;
			this.btnDamagedColour.Click += new System.EventHandler(this.btnDamagedColour_Click);
			// 
			// btnDamagedGrid
			// 
			this.btnDamagedGrid.Location = new System.Drawing.Point(136, 88);
			this.btnDamagedGrid.Name = "btnDamagedGrid";
			this.btnDamagedGrid.Size = new System.Drawing.Size(40, 24);
			this.btnDamagedGrid.TabIndex = 7;
			this.btnDamagedGrid.Text = "Grid";
			this.btnDamagedGrid.Click += new System.EventHandler(this.btnDamagedGrid_Click);
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(8, 88);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(56, 24);
			this.label6.TabIndex = 6;
			this.label6.Text = "Damaged";
			this.label6.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblDockedBR
			// 
			this.lblDockedBR.Location = new System.Drawing.Point(184, 64);
			this.lblDockedBR.Name = "lblDockedBR";
			this.lblDockedBR.Size = new System.Drawing.Size(80, 16);
			this.lblDockedBR.TabIndex = 4;
			this.lblDockedBR.Text = "BR = 0";
			// 
			// lblDockedTL
			// 
			this.lblDockedTL.Location = new System.Drawing.Point(184, 48);
			this.lblDockedTL.Name = "lblDockedTL";
			this.lblDockedTL.Size = new System.Drawing.Size(80, 16);
			this.lblDockedTL.TabIndex = 3;
			this.lblDockedTL.Text = "TL = 0";
			// 
			// btnStart
			// 
			this.btnStart.Location = new System.Drawing.Point(48, 192);
			this.btnStart.Name = "btnStart";
			this.btnStart.Size = new System.Drawing.Size(192, 23);
			this.btnStart.TabIndex = 4;
			this.btnStart.Text = "Start status scan";
			this.btnStart.Click += new System.EventHandler(this.button1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(288, 222);
			this.Controls.Add(this.btnStart);
			this.Controls.Add(this.groupBox1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.groupBox1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void btnDockedColour_Click(object sender, System.EventArgs e)
		{
			action = "getColour0";
		}

		private void btnDamagedColour_Click(object sender, System.EventArgs e)
		{
			action = "getColour1";
		}

		private void btnInfoColour_Click(object sender, System.EventArgs e)
		{
			action = "getColour2";
		}

		private void btnDockedGrid_Click(object sender, System.EventArgs e)
		{
			action = "getGridTL0";
		}

		private void btnDamagedGrid_Click(object sender, System.EventArgs e)
		{
			action = "getGridTL1";
		}

		private void btnInfoGrid_Click(object sender, System.EventArgs e)
		{
			action = "getGridTL2";
		}

		public void MouseMoved(object sender, MouseEventArgs e)
		{
			if(action.StartsWith("getColour"))
			{
				IntPtr hdcScreen = CreateDC("Display", null, null, IntPtr.Zero);
				int x = Cursor.Position.X;
				int y = Cursor.Position.Y;
				int cr = GetPixel(hdcScreen, x, y);
				Color color = Color.FromArgb((cr & 0x000000FF),	(cr & 0x0000FF00) >> 8,	(cr & 0x00FF0000) >> 16);
				DeleteDC(hdcScreen);
				btnColours[int.Parse(action.Substring(action.Length - 1))].BackColor = color; 
				if (e.Clicks>0)
				{
					action = "waiting"; 
				}
			}			
			else if(action.StartsWith("getGridTL"))
			{
				int num = int.Parse(action.Substring(action.Length - 1));
				if (e.Clicks>0)
				{
					pntTL[num].X = Cursor.Position.X;
					pntTL[num].Y = Cursor.Position.Y;
					lblPntTL[num].Text = "TL = " + pntTL[num].X + "," + pntTL[num].Y;
					action = "getGridBR" + num;
				}
			}
			else if(action.StartsWith("getGridBR"))
			{
				int num = int.Parse(action.Substring(action.Length - 1));
				if (e.Clicks>0)
				{
					pntBR[num].X = Cursor.Position.X;
					pntBR[num].Y = Cursor.Position.Y;
					lblPntBR[num].Text = "BR = " + pntBR[num].X + "," + pntBR[num].Y;
					action = "waiting";
				}
			}
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			Thread thrd1=new Thread(new ThreadStart(scanForStatus));
			thrd1.Start();
		}

		public void scanForStatus()
		{
			while(alive)
			{
				bool found = false;

				for(int i=0; i<3; i++)
				{
					for(int x = pntTL[i].X; x < pntBR[i].X; x = x+2 ) //takes a coloumn at a time.
					{
						for(int y = pntTL[i].Y; y < pntBR[i].Y; y = y+2)
						{							
							IntPtr hdcScreen = CreateDC("Display", null, null, IntPtr.Zero);
							int cr = GetPixel(hdcScreen, x, y);
							Color color = Color.FromArgb((cr & 0x000000FF),	(cr & 0x0000FF00) >> 8,	(cr & 0x00FF0000) >> 16);
							DeleteDC(hdcScreen);
							if(color.Equals(btnColours[i].BackColor))
							{
								//							Cursor.Position = new Point(x,y);
								found = true;
								btnStart.Text = "Current status = " + state[i];
								break;
							}
						}
						Thread.Sleep(10);
					}
				}
				if(!found)
				{
					btnStart.Text = "Current status = normal";
				}

			}
		}
	}
}
